| Python Script Engine 8.3 GL Studio Editor Python Script API

Public Member Functions | Static Public Member Functions | List of all members
GlsRenderEffect Class Referenceabstract
Inheritance diagram for GlsRenderEffect:

## Public Member Functions
| GlsRenderEffect (GlsRenderEffect &src)
| GlsRenderEffect (disti::GlsRenderEffect *renderEffect, bool incEditorRef)
virtual void | AddRef ()
virtual void | Release ()
virtual unsigned int | GlsRenderEffect_ClassID ()
virtual void | SetupEffect (MaterialArray &materialPalette, TexturePalette *texturePalette, TextureSettings &textureSettings, float *viewToWorld3x3, unsigned int maxLightNum, unsigned int activeLightMask)
virtual void | CleanupEffect ()
virtual int | Compare (GlsRenderEffect *other)
virtual bool | Equals (GlsRenderEffect *other)
virtual GlsRenderEffect * | Clone ()=0
int | GetVertexAttribIndexForSemantic (int semanticEnum)
int | GetVertexAttribIndexForSemantic (int semanticEnum)=0

## Static Public Member Functions
static unsigned int | SetDebugMode (String modeName, bool value)
static unsigned int | RegisterNewClassID (String debugStr=String())

## Additional Inherited Members
Public Types inherited from VertexAttribIndexLookup
enum | AttributeSemanticEnum { ATTRIB_UNDEFINED = 0 , ATTRIB_POSITION = 0x80000000 , ATTRIB_NORMAL , ATTRIB_BLENDWEIGHT , ATTRIB_TANGENT , ATTRIB_BINORMAL , ATTRIB_BLENDINDICES , ATTRIB_PSIZE , ATTRIB_TEXCOORD0 , ATTRIB_TEXCOORD1 , ATTRIB_TEXCOORD2 , ATTRIB_TEXCOORD3 , ATTRIB_TEXCOORD4 , ATTRIB_TEXCOORD5 , ATTRIB_TEXCOORD6 , ATTRIB_TEXCOORD7 }

## Detailed Description

Render effect class.

Encapsulates an effect that can be applied to the OpenGL state to modify the appearance of geometry. This API currently only supports single pass techniques.

## Constructor & Destructor Documentation

## ◆ GlsRenderEffect() [1/2]

GlsRenderEffect::GlsRenderEffect | ( | GlsRenderEffect & | src | ) |

## ◆ GlsRenderEffect() [2/2]

GlsRenderEffect::GlsRenderEffect | ( | disti::GlsRenderEffect * | renderEffect,
|  | bool | incEditorRef
| ) |  |

ctor

Parameters

  renderEffect | GlsRenderEffect to wrap
  incEditorRef | true if to increment editor ref on with wrapped group (i.e. if this pointer came from the editor) else false

## Member Function Documentation

## ◆ AddRef()

virtual void GlsRenderEffect::AddRef | ( |  | ) |
| virtual

Manage references to the effect.

Reimplemented in Effect_DiffNormSpecRefl.

## ◆ CleanupEffect()

virtual void GlsRenderEffect::CleanupEffect | ( |  | ) |
| virtual

Remove the effect trom the OpenGL state.

Reimplemented in Effect_DiffNormSpecRefl.

## ◆ Clone()

virtual GlsRenderEffect * GlsRenderEffect::Clone | ( |  | ) |
| pure virtual

Returns a new instance of the effect with the same settings as this one.

Implemented in Effect_DiffNormSpecRefl.

## ◆ Compare()

virtual int GlsRenderEffect::Compare | ( | GlsRenderEffect * | other | ) |
| virtual

Returns 0 if the effects are equal, a positive number if this effect should sort after the other effect, and a negative number if this effect should sort before the other effect.

The rendering system uses this to sort effects.

Reimplemented in Effect_DiffNormSpecRefl.

## ◆ Equals()

virtual bool GlsRenderEffect::Equals | ( | GlsRenderEffect * | other | ) |
| virtual

Determine if two GlsRenderEffect instances are equivalent The rendering system uses this to eliminate redundant effects.

## ◆ GetVertexAttribIndexForSemantic()

int GlsRenderEffect::GetVertexAttribIndexForSemantic | ( | int | semanticEnum | ) |
| virtual

VertexAttribIndexLookup override /////////////////////////////////////////.

Returns
  The attributeIndex that should be used to pass the vertex attributes or -1 if they are not needed (see glVertexAttrib)

Parameters

  semanticEnum | The sematic value (see AttributeSemanticEnum)

Implements VertexAttribIndexLookup.

## ◆ GlsRenderEffect_ClassID()

virtual unsigned int GlsRenderEffect::GlsRenderEffect_ClassID | ( |  | ) |
| virtual

Reimplemented in Effect_DiffNormSpecRefl.

## ◆ RegisterNewClassID()

static unsigned int GlsRenderEffect::RegisterNewClassID | ( | String | debugStr = `String()` | ) |
| static

## ◆ Release()

virtual void GlsRenderEffect::Release | ( |  | ) |
| virtual

Reimplemented in Effect_DiffNormSpecRefl.

## ◆ SetDebugMode()

static unsigned int GlsRenderEffect::SetDebugMode | ( | String | modeName,
|  | bool | value
| ) |  |
| static

## ◆ SetupEffect()

virtual void GlsRenderEffect::SetupEffect | ( | MaterialArray & | materialPalette,
|  | TexturePalette * | texturePalette,
|  | TextureSettings & | textureSettings,
|  | float * | viewToWorld3x3,
|  | unsigned int | maxLightNum,
|  | unsigned int | activeLightMask
| ) |  |
| virtual

Apply the effect to the OpenGL state.

Parameters

  materialPalette | Used to access material settings
  texturePalette | Used to access texture maps
  textureSettings | The object-level texture settings
  viewToWorld3x3 | A 3x3 matrix containing the current viewToWorld transfrom. Used for environment mapping effects.
  maxLightNum | Maximum number of active lights
  activeLightMask | Bit mask for active lights in scene

Reimplemented in Effect_DiffNormSpecRefl.

The documentation for this class was generated from the following file:

- GlsRenderEffect.i